package eu.dnetlib.data.mdstore;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import eu.dnetlib.common.controller.AbstractDnetController;
import eu.dnetlib.data.mdstore.hadoop.ZeppelinClient;
import eu.dnetlib.errors.MDStoreManagerException;

@RestController
@RequestMapping("/zeppelin")
public class ZeppelinAjaxController extends AbstractDnetController {

	@Autowired
	private ZeppelinClient zeppelinClient;

	@GetMapping("/templates")
	public List<String> getTemplates() throws MDStoreManagerException {
		try {
			return zeppelinClient.listTemplates();
		} catch (final Throwable e) {
			throw new MDStoreManagerException("Zeppelin is unreachable", e);
		}
	}

}
