package eu.dnetlib.is.email;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import eu.dnetlib.common.controller.AbstractDnetController;
import eu.dnetlib.common.model.EmailTemplate;
import eu.dnetlib.notifications.mail.EmailService;

@RestController
@RequestMapping("/ajax/templates/email")
public class EmailTemplateController extends AbstractDnetController {

	@Autowired
	protected EmailService emailService;

	@GetMapping("/")
	public List<EmailTemplate> listEmailTemplates() {
		return emailService.listEmailTemplates();
	}

	@PostMapping("/")
	public List<EmailTemplate> saveEmailTemplate(@RequestBody final EmailTemplate email) {
		emailService.saveEmailTemplate(email);
		return emailService.listEmailTemplates();
	}

	@DeleteMapping("/{id}")
	public List<EmailTemplate> deleteEmailTemplate(@PathVariable final String id) {
		emailService.deleteEmailTemplate(id);
		return emailService.listEmailTemplates();
	}
}
