package eu.dnetlib.manager.wf;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import eu.dnetlib.common.controller.AbstractDnetController;
import eu.dnetlib.manager.history.WorkflowLogger;
import eu.dnetlib.manager.history.model.WfHistoryEntry;

@RestController
@RequestMapping("/ajax/wf_history")
public class WfHistoryAjaxController extends AbstractDnetController {

	@Autowired
	private WorkflowLogger logger;

	@GetMapping("/")
	public List<WfHistoryEntry> history(
		@RequestParam(required = true) final int total,
		@RequestParam(required = false) final Long from,
		@RequestParam(required = false) final Long to) {
		return logger.history(total, from, to);
	}

	@GetMapping("/byConf/{wfConfId}")
	public List<WfHistoryEntry> history(@PathVariable final String wfConfId) {
		return logger.history(wfConfId);
	}

	@GetMapping("/proc/{processId}")
	public WfHistoryEntry getProcessExecution(@PathVariable final String processId) {
		return logger.getLog(processId);
	}

}
