import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { InfoComponent } from './info/info.component';
import { ProtocolsComponent } from './protocols/protocols.component';
import { WfHistoryComponent } from './wf-history/wf-history.component';
import { ResourcesComponent } from './resources/resources.component';
import { VocabulariesComponent, VocabularyEditorComponent } from './vocabularies/vocabularies.component';
import { ContextViewerComponent, ContextsComponent } from './contexts/contexts.component';
import { DsmSearchComponent, DsmResultsComponent, DsmApiComponent } from './dsm/dsm.component';
import { MdstoreInspectorComponent, MdstoresComponent } from './mdstores/mdstores.component';
import { CleanerTesterComponent } from './cleaner-tester/cleaner-tester.component';
import { EmailsComponent } from './emails/emails.component';
import { WfConfsComponent } from './wf-confs/wf-confs.component';

const routes: Routes = [
	{ path: "", redirectTo: 'info', pathMatch: 'full' },
	{ path: "info", component: InfoComponent },
	{ path: "resources/:type", component: ResourcesComponent },
	{ path: "adv_resources/context", component: ContextsComponent },
	{ path: "adv_resources/vocabulary", component: VocabulariesComponent },
	{ path: "adv_resources/protocol", component: ProtocolsComponent },
	{ path: "adv_resources/email", component: EmailsComponent },
	{ path: "wfs/:section", component: WfConfsComponent },
	{ path: "wfs/conf/:conf", component: WfConfsComponent },
	{ path: "wf_history", component: WfHistoryComponent },
	{ path: "ctx_viewer", component: ContextViewerComponent },
	{ path: "voc_editor", component: VocabularyEditorComponent },
	{ path: "dsm/search", component: DsmSearchComponent },
	{ path: "dsm/results/:page/:size", component: DsmResultsComponent },
	{ path: "mdstores", component: MdstoresComponent },
	{ path: "mdrecords/:versionId/:limit", component: MdstoreInspectorComponent },
	{ path: "cleaner", component: CleanerTesterComponent }
];

@NgModule({
	imports: [RouterModule.forRoot(routes)],
	exports: [RouterModule]
})
export class AppRoutingModule { }
