import { Component, ViewChild } from '@angular/core';
import { KeyValue, ResourceType, WfSection } from '../common/is.model';
import { ISService } from '../common/is.service';
import { MatAccordion } from '@angular/material/expansion';


@Component({
	selector: 'app-main-menu-panels',
	templateUrl: './main-menu-panels.component.html',
	styleUrls: ['./main-menu-panels.component.css']
})
export class MainMenuPanelsComponent {

	@ViewChild(MatAccordion)
	accordion!: MatAccordion;

	resTypes: ResourceType[] = [];
	wfSections: WfSection[] = [];

	constructor(public service: ISService) {
		service.loadResourceTypes((data: ResourceType[]) => this.resTypes = data);
		service.loadWfSections((data: WfSection[]) => this.wfSections = data);
	}
}
