package eu.dnetlib.data.collect;

import java.time.LocalDateTime;
import java.util.List;
import java.util.stream.Stream;

import org.springframework.stereotype.Service;

import eu.dnetlib.dsm.model.Api;

@Service
public class CollectorService {

	private List<DnetCollector> collectors;

	public Stream<String> collect(final Api api) {
		return collectors.stream()
			.filter(coll -> coll.protocol().equalsIgnoreCase(api.getProtocol()))
			.findFirst()
			.map(coll -> coll.collect(api.getBaseurl(), api.getApiParams()))
			.orElseThrow();
	}

	public Stream<String> collect(final Api api, final LocalDateTime from, final LocalDateTime until) {
		return collectors.stream()
			.filter(coll -> coll.protocol().equalsIgnoreCase(api.getProtocol()))
			.findFirst()
			.map(coll -> coll.collect(api.getBaseurl(), api.getApiParams(), from, until))
			.orElseThrow();
	}
}
