package eu.dnetlib.data.mdstore.backends;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import java.util.stream.Stream;

import org.springframework.stereotype.Service;

import eu.dnetlib.data.mdstore.model.MDStore;
import eu.dnetlib.data.mdstore.model.MDStoreVersion;
import eu.dnetlib.data.mdstore.model.records.MetadataRecord;
import eu.dnetlib.errors.MDStoreManagerException;

@Service
public class DefaultBackend implements MDStoreBackend {

	@Override
	public void completeNewMDStore(final MDStore mdstore) {}

	@Override
	public void completeNewMDStoreVersion(final MDStoreVersion version) {}

	@Override
	public void delete(final MDStore mdstore) throws MDStoreManagerException {}

	@Override
	public void delete(final MDStoreVersion version) throws MDStoreManagerException {}

	@Override
	public List<MetadataRecord> listEntries(final MDStoreVersion version, final long limit) throws MDStoreManagerException {
		return new ArrayList<>();
	}

	@Override
	public Stream<MetadataRecord> streamEntries(final MDStoreVersion version) throws MDStoreManagerException {
		return Stream.empty();
	}

	@Override
	public Set<String> listInternalFiles(final MDStoreVersion version) throws MDStoreManagerException {
		return new LinkedHashSet<>();
	}

	@Override
	public Set<String> fixInconsistencies(final boolean delete) throws MDStoreManagerException {
		return new HashSet<>();
	}

	@Override
	public void addRecord(final MetadataRecord record) {}

	@Override
	public long countRecords(final String versionId) {
		return 0;
	}

}
