package eu.dnetlib.data.mdstore.backends;

import java.util.List;
import java.util.Set;
import java.util.stream.Stream;

import eu.dnetlib.data.mdstore.model.MDStore;
import eu.dnetlib.data.mdstore.model.MDStoreVersion;
import eu.dnetlib.data.mdstore.model.records.MetadataRecord;
import eu.dnetlib.errors.MDStoreManagerException;

public interface MDStoreBackend {

	void completeNewMDStore(MDStore mdstore);

	void completeNewMDStoreVersion(MDStoreVersion version);

	void delete(MDStore mdstore) throws MDStoreManagerException;

	void delete(MDStoreVersion version) throws MDStoreManagerException;

	List<MetadataRecord> listEntries(MDStoreVersion version, long limit) throws MDStoreManagerException;

	Stream<MetadataRecord> streamEntries(MDStoreVersion version) throws MDStoreManagerException;

	Set<String> listInternalFiles(MDStoreVersion version) throws MDStoreManagerException;

	Set<String> fixInconsistencies(boolean delete) throws MDStoreManagerException;

	void addRecord(MetadataRecord record);

	long countRecords(String versionId);

}
