package eu.dnetlib.data.mdstore.model.records;

/**
 * This class models a record in a Metadata store collection
 */
public class MetadataRecordImpl implements MetadataRecord {

	private static final long serialVersionUID = -226995288313973437L;

	private String id;
	private String originalId;
	private String encoding;
	private Provenance provenance;
	private String body;
	private Long dateOfCollection;
	private Long dateOfTransformation;

	public MetadataRecordImpl() {}

	public MetadataRecordImpl(
		final String originalId,
		final String encoding,
		final Provenance provenance,
		final String body,
		final Long dateOfCollection) {

		this.originalId = originalId;
		this.encoding = encoding;
		this.provenance = provenance;
		this.body = body;
		this.dateOfCollection = dateOfCollection;
		this.id = MetadataRecord.generateIdentifier(originalId, this.provenance.getNsPrefix());
	}

	@Override
	public String getId() {
		return id;
	}

	@Override
	public void setId(final String id) {
		this.id = id;
	}

	@Override
	public String getOriginalId() {
		return originalId;
	}

	@Override
	public void setOriginalId(final String originalId) {
		this.originalId = originalId;
	}

	@Override
	public String getEncoding() {
		return encoding;
	}

	@Override
	public void setEncoding(final String encoding) {
		this.encoding = encoding;
	}

	@Override
	public Provenance getProvenance() {
		return provenance;
	}

	@Override
	public void setProvenance(final Provenance provenance) {
		this.provenance = provenance;
	}

	@Override
	public String getBody() {
		return body;
	}

	@Override
	public void setBody(final String body) {
		this.body = body;
	}

	@Override
	public Long getDateOfCollection() {
		return dateOfCollection;
	}

	@Override
	public void setDateOfCollection(final Long dateOfCollection) {
		this.dateOfCollection = dateOfCollection;
	}

	@Override
	public Long getDateOfTransformation() {
		return dateOfTransformation;
	}

	@Override
	public void setDateOfTransformation(final Long dateOfTransformation) {
		this.dateOfTransformation = dateOfTransformation;
	}

	@Override
	public boolean equals(final Object o) {
		if (!(o instanceof MetadataRecord)) { return false; }
		return ((MetadataRecord) o).getId().equalsIgnoreCase(id);
	}

	@Override
	public int hashCode() {
		return id.hashCode();
	}
}
