package eu.dnetlib.manager.history.repository;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Optional;

import org.springframework.data.jpa.repository.JpaRepository;

import eu.dnetlib.manager.history.model.WfHistoryEntry;

public interface WfHistoryEntryRepository extends JpaRepository<WfHistoryEntry, String> {

	List<WfHistoryEntry> findByEndDateBetweenOrderByEndDateDesc(LocalDateTime start, LocalDateTime end);

	List<WfHistoryEntry> findByWfConfigurationIdOrderByEndDateDesc(String id);

	Optional<WfHistoryEntry> findFirstByWfConfigurationIdOrderByEndDateDesc(String id);
}
