package eu.dnetlib.manager.wf.nodes.collect;

import java.util.stream.Stream;

import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.data.collect.CollectorService;
import eu.dnetlib.dsm.model.Api;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.nodes.stream.StreamSupplierNode;

@WfNode("collect")
public class CollectNode extends StreamSupplierNode<String> {

	@WfInputParam
	private Api api;

	@Autowired
	private CollectorService collectorService;

	@Override
	protected Stream<String> prepareStream() {
		return collectorService.collect(api);
	}

	@Override
	protected void before() {}

	@Override
	protected void after() {}

	@Override
	protected void abort() {}

}
