package eu.dnetlib.manager.wf.nodes.collect;

import java.time.LocalDateTime;
import java.util.stream.Stream;

import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.data.collect.CollectorService;
import eu.dnetlib.dsm.model.Api;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.nodes.stream.StreamSupplierNode;

@WfNode("dateRangeCollect")
public class DateRangeCollectNode extends StreamSupplierNode<String> {

	@WfInputParam
	private Api api;

	@WfInputParam
	private LocalDateTime from;

	@WfInputParam
	private LocalDateTime until;

	@Autowired
	private CollectorService collectorService;

	@Override
	protected Stream<String> prepareStream() {
		return collectorService.collect(api, from, until);
	}

	@Override
	protected void before() {}

	@Override
	protected void after() {}

	@Override
	protected void abort() {}

}
