package eu.dnetlib.manager.wf.nodes.collect;

import java.time.LocalDateTime;

import eu.dnetlib.dsm.model.Api;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.annotations.WfOutputParam;
import eu.dnetlib.manager.wf.nodes.AbstractJobNode;

@WfNode("findDateRangeForIncrementalHarvesting")
public class FindDateRangeForIncrementalHarvestingNode extends AbstractJobNode {

	@WfInputParam
	private Api api;

	@WfInputParam
	private LocalDateTime overrideFromDate;

	@WfInputParam
	private LocalDateTime overrideUntilDate;

	@WfOutputParam
	private LocalDateTime fromDate;

	@WfOutputParam
	private LocalDateTime untilDate;

	@Override
	protected void execute() throws Exception {
		fromDate = overrideFromDate != null ? overrideFromDate : findLastCollDate();
		untilDate = overrideUntilDate != null ? overrideUntilDate : null;
	}

	private LocalDateTime findLastCollDate() {
		return api.getLastCollectionDate() != null ? api.getLastCollectionDate().toLocalDateTime() : null;
	}

}
