package eu.dnetlib.manager.wf.nodes.ds;

import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.dsm.DsmService;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.nodes.AbstractJobNode;

@WfNode("clearApiExtraFields")
public class ClearApiExtraFieldsNode extends AbstractJobNode {

	@WfInputParam
	private String dsId;
	@WfInputParam
	private String apiId;
	@WfInputParam
	private String infoType; // COLLECT, TRANSFORM, DOWNLOAD

	@Autowired
	private DsmService dsmService;

	@Override
	protected void execute() throws Exception {

		switch (infoType.toUpperCase()) {
		case "COLLECT":
			dsmService.updateUpdateApiCollectionInfo(apiId, null, 0);
			break;
		case "AGGREGATOR":
		case "TRANSFORM":
			dsmService.updateUpdateApiAggregationInfo(apiId, null, 0);
			break;
		case "DOWNLOAD":
			dsmService.updateUpdateApiDownloadInfo(apiId, null, 0);
			break;
		default:
			throw new RuntimeException("Invalid infoType: " + infoType);
		}

	}

}
