package eu.dnetlib.manager.wf.nodes.ds;

import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.dsm.DsmService;
import eu.dnetlib.dsm.model.Api;
import eu.dnetlib.dsm.model.Datasource;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.annotations.WfOutputParam;
import eu.dnetlib.manager.wf.nodes.AbstractJobNode;

@WfNode("loadDatasourceInfo")
public class LoadDatasourceInfoNode extends AbstractJobNode {

	@WfInputParam
	private String dsId;

	@WfInputParam
	private String apiId;

	@WfOutputParam
	private Datasource ds;

	@WfOutputParam
	private Api api;

	@Autowired
	private DsmService dsmService;

	@Override
	protected void execute() throws Exception {
		ds = dsmService.findDs(dsId);
		api = dsmService.findApi(apiId);

	}

}
