package eu.dnetlib.manager.wf.nodes.ds;

import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.dsm.DsmService;
import eu.dnetlib.dsm.model.Api;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.annotations.WfOutputParam;
import eu.dnetlib.manager.wf.nodes.AbstractJobNode;

@WfNode("updateApiExtraFields")
public class UpdateApiExtraFieldsNode extends AbstractJobNode {

	@WfInputParam
	@WfOutputParam
	private Api api;

	@WfInputParam
	private String infoType; // COLLECT, TRANSFORM, DOWNLOAD

	@WfInputParam
	private String mdId;

	@WfInputParam
	private long total;

	@Autowired
	private DsmService dsmService;

	@Override
	protected void execute() throws Exception {

		switch (infoType.toUpperCase()) {
		case "COLLECT":
			api = dsmService.updateUpdateApiCollectionInfo(api.getId(), mdId, total);
			break;
		case "AGGREGATOR":
		case "TRANSFORM":
			api = dsmService.updateUpdateApiAggregationInfo(api.getId(), mdId, total);
			break;
		case "DOWNLOAD":
			api = dsmService.updateUpdateApiDownloadInfo(api.getId(), mdId, total);
			break;
		default:
			throw new RuntimeException("Invalid infoType: " + infoType);
		}

	}

}
