package eu.dnetlib.manager.wf.nodes.ds;

import java.util.Arrays;

import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

import eu.dnetlib.dsm.model.Api;
import eu.dnetlib.dsm.model.Datasource;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.nodes.AbstractJobNode;

@WfNode("verifyDatasource")
public class VerifyDatasourceNode extends AbstractJobNode {

	@WfInputParam
	private String expectedEoscDatasourceTypes;

	@WfInputParam
	private String expectedCompatibilities;

	@WfInputParam
	private Datasource ds;

	@WfInputParam
	private Api api;

	@Override
	protected void execute() throws Exception {
		final String type = ds.getEoscDatasourceType();
		final String compatibility = ObjectUtils.firstNonNull(api.getCompatibilityOverride(), api.getCompatibility());

		if (StringUtils.isNotBlank(expectedEoscDatasourceTypes)) {
			Arrays.stream(expectedEoscDatasourceTypes.split(","))
				.filter(StringUtils::isNotBlank)
				.filter(s -> s.equalsIgnoreCase(type))
				.findFirst()
				.orElseThrow(() -> new Exception("Invalid type: " + type));
		}

		if (StringUtils.isNotBlank(expectedCompatibilities)) {
			Arrays.stream(expectedCompatibilities.split(","))
				.filter(StringUtils::isNotBlank)
				.filter(s -> s.equalsIgnoreCase(compatibility))
				.findFirst()
				.orElseThrow(() -> new Exception("Invalid type: " + compatibility));;
		}

	}

}
