package eu.dnetlib.manager.wf.nodes.store;

import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.data.mdstore.MDStoreService;
import eu.dnetlib.data.mdstore.model.MDStoreType;
import eu.dnetlib.dsm.model.Api;
import eu.dnetlib.dsm.model.Datasource;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.annotations.WfOutputParam;
import eu.dnetlib.manager.wf.nodes.AbstractJobNode;

@WfNode("createMdStore")
public class CreateMdStoreNode extends AbstractJobNode {

	@WfInputParam
	private String format;

	@WfInputParam
	private String layout;

	@WfInputParam
	private String interpretation;

	@WfInputParam
	private String backend;

	@WfInputParam
	private Datasource ds;

	@WfInputParam
	private Api api;

	@WfOutputParam
	private String mdId;

	@Autowired
	private MDStoreService mdStoreService;

	@Override
	protected void execute() throws Exception {
		mdId = mdStoreService.createMDStore(format, layout, interpretation, MDStoreType.valueOf(backend), ds.getOfficialname(), ds.getId(), api.getId());
	}

}
