package eu.dnetlib.manager.wf.nodes.stream;

import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.nodes.AbstractJobNode;

public abstract class StreamConsumerNode<T> extends AbstractJobNode {

	@WfInputParam
	private DnetStream<T> inputStream;

	abstract protected void init() throws Exception;

	abstract protected void consumeRecord(T input) throws Exception;

	abstract protected void complete() throws Exception;

	@Override
	protected final void execute() throws Exception {
		init();
		inputStream.consume(x -> {
			try {
				consumeRecord(x);
			} catch (final Exception e) {
				throw new RuntimeException(e);
			}
		});
		complete();
	}

}
