package eu.dnetlib.manager.wf.nodes.stream;

import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfOutputParam;
import eu.dnetlib.manager.wf.nodes.AbstractJobNode;

public abstract class StreamFilterNode<T> extends AbstractJobNode {

	@WfInputParam
	private DnetStream<T> inputStream;

	@WfOutputParam
	private DnetStream<T> outputStream;

	abstract protected void init() throws Exception;

	abstract protected boolean filterRecord(T obj) throws Exception;

	@Override
	protected final void execute() throws Exception {
		init();
		outputStream = inputStream.filter(x -> {
			try {
				return filterRecord(x);
			} catch (final Exception e) {
				throw new RuntimeException(e);
			}
		});
	}

}
