package eu.dnetlib.manager.wf.nodes.stream;

import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfOutputParam;
import eu.dnetlib.manager.wf.nodes.AbstractJobNode;

public abstract class StreamMapperNode<T, K> extends AbstractJobNode {

	@WfInputParam
	private DnetStream<T> inputStream;

	@WfOutputParam
	private DnetStream<K> outputStream;

	abstract protected void init() throws Exception;

	abstract protected K mapRecord(T input) throws Exception;

	@Override
	protected void execute() throws Exception {
		init();
		outputStream = inputStream.map(x -> {
			try {
				return mapRecord(x);
			} catch (final Exception e) {
				throw new RuntimeException(e);
			}
		});
	}

}
