package eu.dnetlib.manager.wf.nodes.stream;

import java.util.stream.Stream;

import eu.dnetlib.manager.wf.annotations.WfOutputParam;
import eu.dnetlib.manager.wf.nodes.AbstractJobNode;

public abstract class StreamSupplierNode<T> extends AbstractJobNode {

	@WfOutputParam
	private DnetStream<T> outputStream;

	abstract protected Stream<T> prepareStream() throws Exception;

	abstract protected void before() throws Exception;

	abstract protected void after() throws Exception;

	abstract protected void abort() throws Exception;

	@Override
	protected void execute() throws Exception {
		outputStream = new DnetStream<>(prepareStream(), this::before, this::after, this::abort);
	}

}
