package eu.dnetlib.manager.wf.nodes.transfrom;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.data.mapping.cleaner.Cleaner;
import eu.dnetlib.data.mapping.cleaner.CleanerFactory;
import eu.dnetlib.data.mdstore.model.records.MetadataRecord;
import eu.dnetlib.data.mdstore.model.records.MetadataRecordImpl;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.nodes.stream.StreamMapperNode;

@WfNode("clean")
public class MetadataCleanerNode extends StreamMapperNode<MetadataRecord, MetadataRecord> {

	@WfInputParam
	private String ruleId;

	@Autowired
	private CleanerFactory cleanerFactory;

	private Cleaner cleaner;

	@Override
	protected void init() throws Exception {
		cleaner = cleanerFactory.obtainCleaningRule(ruleId);
	}

	@Override
	protected MetadataRecord mapRecord(final MetadataRecord input) throws Exception {
		final MetadataRecord out = new MetadataRecordImpl();
		BeanUtils.copyProperties(input, out);
		out.setBody(cleaner.transform(input.getBody()));
		out.setDateOfTransformation(System.currentTimeMillis());
		return out;
	}

}
