package eu.dnetlib.manager.wf.nodes.transfrom;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.DocumentHelper;

import eu.dnetlib.data.mdstore.model.records.MetadataRecord;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.nodes.stream.StreamFilterNode;

@WfNode("xpath_filter")
public class MetadataFilterNode extends StreamFilterNode<MetadataRecord> {

	@WfInputParam
	private String xpath;

	@Override
	protected void init() throws Exception {}

	@Override
	protected boolean filterRecord(final MetadataRecord input) throws Exception {
		try {
			final Document doc = DocumentHelper.parseText(input.getBody());
			return !doc.selectNodes(xpath).isEmpty();
		} catch (final DocumentException e) {
			throw new RuntimeException(e);
		}
	}

}
