package eu.dnetlib.manager.wf.nodes.transfrom;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.data.mapping.RecordTransformer;
import eu.dnetlib.data.mapping.xslt.XsltTransformFactory;
import eu.dnetlib.data.mdstore.model.records.MetadataRecord;
import eu.dnetlib.data.mdstore.model.records.MetadataRecordImpl;
import eu.dnetlib.manager.wf.annotations.WfInputParam;
import eu.dnetlib.manager.wf.annotations.WfNode;
import eu.dnetlib.manager.wf.nodes.stream.StreamMapperNode;

@WfNode("applyXslt")
public class MetadataXsltTransformNode extends StreamMapperNode<MetadataRecord, MetadataRecord> {

	@WfInputParam
	private String ruleId;

	@Autowired
	private XsltTransformFactory xsltTransformFactory;

	private RecordTransformer<String, String> xslt;
	private long now;

	@Override
	protected void init() throws Exception {
		now = System.currentTimeMillis();

		final Map<String, String> params = new HashMap<>();
		// TODO: which params ?

		xslt = xsltTransformFactory.getTransformer(ruleId, params);
	}

	@Override
	protected MetadataRecord mapRecord(final MetadataRecord input) throws Exception {
		final MetadataRecord output = new MetadataRecordImpl();
		BeanUtils.copyProperties(input, output);
		output.setBody(xslt.transform(input.getBody()));
		output.setDateOfTransformation(now);
		return output;
	}

}
