package eu.dnetlib.manager.wf.workflows.graph;

import java.util.function.Function;

import eu.dnetlib.manager.wf.workflows.procs.Env;

public class Arc {

	private final String from;
	private final String to;
	private final Function<Env, Boolean> condFunction;

	public Arc(final String from, final String to, final Function<Env, Boolean> condFunction) {
		this.from = from;
		this.to = to;
		this.condFunction = condFunction;
	}

	public String getFrom() {
		return this.from;
	}

	public String getTo() {
		return this.to;
	}

	public boolean isValid(final Env env) {
		if (condFunction != null) {
			return condFunction.apply(env);
		} else {
			return true;
		}
	}

	@Override
	public String toString() {
		return String.format("[ %s -> %s ]", this.from, this.to);
	}

}
